<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Unit Conversion and Dimensional Analysis Library: Unit Types</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Unit Conversion and Dimensional Analysis Library
   &#160;<span id="projectnumber">2.3.0</span>
   </div>
   <div id="projectbrief">A compile-time c++14 unit conversion library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#typedef-members">Typedefs</a>  </div>
  <div class="headertitle">
<div class="title">Unit Types</div>  </div>
</div><!--header-->
<div class="contents">

<p>Defines a series of classes which represent units. These types are tags used by the conversion function, to create compound units, or to create <code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> types. By themselves, they are not containers and have no stored value.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1base__unit.html">units::base_unit&lt; Meter, Kilogram, Second, Radian, Ampere, Kelvin, Mole, Candela, Byte &gt;</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class representing SI base unit types.  <a href="structunits_1_1base__unit.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structunits_1_1unit.html">units::unit&lt; Conversion, BaseUnit, PiExponent, Translation &gt;</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type representing an arbitrary unit.  <a href="structunits_1_1unit.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ga36d8b8cf508bd5ac7854d15f6eaf2d7c"><td class="memTemplParams" colspan="2">template&lt;class U , class... Us&gt; </td></tr>
<tr class="memitem:ga36d8b8cf508bd5ac7854d15f6eaf2d7c"><td class="memTemplItemLeft" align="right" valign="top">using&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_types.html#ga36d8b8cf508bd5ac7854d15f6eaf2d7c">units::compound_unit</a> = typename units::detail::compound_impl&lt; U, Us... &gt;::type</td></tr>
<tr class="memdesc:ga36d8b8cf508bd5ac7854d15f6eaf2d7c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Represents a unit type made up from other units.  <a href="group___unit_types.html#ga36d8b8cf508bd5ac7854d15f6eaf2d7c">More...</a><br /></td></tr>
<tr class="separator:ga36d8b8cf508bd5ac7854d15f6eaf2d7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>Defines a series of classes which represent units. These types are tags used by the conversion function, to create compound units, or to create <code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> types. By themselves, they are not containers and have no stored value. </p>
<h2 class="groupheader">Typedef Documentation</h2>
<a id="ga36d8b8cf508bd5ac7854d15f6eaf2d7c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga36d8b8cf508bd5ac7854d15f6eaf2d7c">&#9670;&nbsp;</a></span>compound_unit</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class U , class... Us&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="group___unit_types.html#ga36d8b8cf508bd5ac7854d15f6eaf2d7c">units::compound_unit</a> = typedef typename units::detail::compound_impl&lt;U, Us...&gt;::type</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Represents a unit type made up from other units. </p>
<p>Compound units are formed by multiplying the units of all the types provided in the template argument. Types provided must inherit from <code>unit</code>. A compound unit can be formed from any number of other units, and unit manipulators like <code>inverse</code> and <code>squared</code> are supported. E.g. to specify acceleration, on could create <code>using acceleration = compound_unit&lt;length::meters, inverse&lt;squared&lt;seconds&gt;&gt;;</code> </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">U...</td><td>units which, when multiplied together, form the desired compound unit. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Oct 3 2020 11:16:53 for Unit Conversion and Dimensional Analysis Library by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
